<%- include('./include/header.ejs'); -%>

    <body class="hold-transition sidebar-mini " style="height: auto; width: auto;">
        <%- include('./include/navBar.ejs'); -%>
            <%- include('./include/slideBar.ejs'); -%>
                <section class="content-wrapper">
                    <div class="container-fluid width: auto">
                        <div class="row">
                            <div class="col-12">
                                <div class="card">
                                    <div class="card-header">
                                        <h3 class="card-title">Product list</h3>
                                        <button type="button" class="btn btn-primary float-right " id="addProduct">Add
                                            product</button>
                                    </div>
                                    <!-- /.card-header -->
                                    <div class="card-body">
                                        <table id="dataTable" class="table table-bordered table-hover">
                                            <thead>
                                                <tr>
                                                    <th>name</th>
                                                    <th>description</th>
                                                    <th>price</th>
                                                    <th>sellPrice</th>
                                                    <th>category</th>
                                                    <th>images</th>
                                                    <th>action</th>
                                                </tr>
                                            </thead>
                                        </table>
                                    </div>
                                    <!-- /.card-body -->
                                </div>
                                <!-- /.card -->
                                <div class="float-right ">
                                    <a href="/admin/user/home/view">Back to home >>></a>
                                </div>
                            </div>
                            <!-- /.col -->
                        </div>
                    </div>
                </section>
                <%- include('./include/footer.ejs'); -%>
                    <script>
                        $(document).ready(function () {
                            $("#addProduct").click(function () {
                                window.location.href = "/admin/product/add/view"
                            })
                            $('#dataTable').DataTable({
                                'responsive': true,
                                "paging": true,
                                "searching": true,
                                "ordering": true,
                                "serverSide": true,
                                "lengthChange": true    ,
                                ajax: {
                                    url: "/admin/product/list",
                                    method: 'get',
                                    dataType: 'json',
                                    headers: { "Authorization": "Bearer " + localStorage.getItem("token") },
                                    data: function (dataTable) {
                                        dataTable.perPage = dataTable.length
                                        if (dataTable.search) {
                                            dataTable.search = dataTable.search.value
                                        }
                                        if (dataTable.order.length > 0) {
                                            dataTable.sortType = dataTable.order[0].dir
                                            dataTable.sortField = dataTable.columns[dataTable.order[0].column].data
                                        }
                                        dataTable.page = (dataTable.start / dataTable.length) + 1
                                        return dataTable.data;

                                    },
                                    search: {
                                        return: true,
                                    },
                                },

                                columns: [
                                    { 'title': 'name', 'data': 'name', 'sWidth': "15%" },
                                    { 'title': 'description', 'data': 'description', 'sWidth': "30%" },
                                    { 'title': 'price', 'data': 'price', "sWidth": "10%" },
                                    { 'title': 'sellPrice', 'data': 'sellPrice', 'sWidth': "10%" },
                                    { 'title': ' category', 'data': 'category', 'sWidth': "15%" },
                                    {
                                        'title': 'images',
                                        "data": "images",
                                        "render": function (data) {
                                            return `<img src='${data[0]}' width="100px">`;
                                        },
                                        'sWidth': "15%"
                                    },
                                    {
                                        'title': "action", "data": "_id",
                                        render: function (data) {
                                            return `<button style='font-size:12px;'  id='editButton' onclick='window.location=\"/admin/product/update/view/${data}\";'><span class='fas fa-edit' > </span></button>  <button style='font-size:12px; color:red;' id='deleteButton' onclick='deleteProduct(\"${data}\");'><span class='fa fa-trash ' aria-hidden='true'></span></button>`;
                                        },
                                        'sWidth': "5%"
                                    },
                                ],
                                'autoWidth': false,
                                "order": [[1, "asc"]],
                                error: function (error) {
                                    console.log(error)
                                }
                            })
                        })
                        function deleteProduct(productId) {
                            $.ajax({
                                url: `/admin/product/delete/${productId}`,
                                method: 'delete',
                                dataType: 'json',
                                headers: { "Authorization": "Bearer " + localStorage.getItem("token") },
                                success: function (data) {
                                    if (data.responseCode == 200) {
                                        toastr.success(data.responseMessage)
                                        $('#dataTable').DataTable().ajax.reload()
                                    }
                                    if (data.responseCode == 400) {
                                        toastr.error(data.responseMessage)
                                    }
                                },
                                error: function (data) {
                                    console.log(data);
                                },
                            })
                        }
                    </script>
    </body>

    </html>